#include <stdio.h>
#include <stdlib.h>
#include <iconv.h>
#include <unistd.h>
#include <netinet/in.h>
#define BUFSIZE 64

int main(int argc, char *argv[])
{
	iconv_t ip;
	unsigned char input[2];
	unsigned char output[1];
	size_t insize;
	size_t outsize;
	unsigned short *unisymbol;
	const char *pinput;
	char *poutput;
	int flag, n, offset=0;
	unsigned char buf[BUFSIZE];


	if(argc !=2 ) {
		fprintf(stderr,"Use as %s output_encoding\n", argv[0]);
		return -1;
	}
	ip=iconv_open(argv[1], "UNICODELITTLE");
	if( ip <= 0) {
		fprintf(stderr, "Failed to init conversion\n");
		perror("iconv");
	}
	while(0 != (flag=read(0, &buf[offset], BUFSIZE-offset))) {
		flag=flag+offset;
		n=0;
		while(n <= (flag-8)) {
			while(n <= (flag-8) && sscanf(&buf[n], "\\%03hho\\%03hho", &input[1], &input[0]) == 2) {
				n=n+8;
				insize=2;
				outsize=1;
				unisymbol=(unsigned short *)input;
				*unisymbol=htons(*unisymbol);
				pinput=(const char *)input;
				poutput=(char *)output;
				output[0]=' ';
				if(iconv(ip, &pinput, &insize, &poutput, &outsize) == -1)
					fprintf(stderr,"Error converting character\n");
				printf("\\%03hho", output[0]);
			}
			if(n <= (flag-8)) {
				putchar(buf[n]);
				n++;
			}
		}
		if(n > (flag-8)) {
			if(flag <8)
				offset=flag;
			else {
				offset=flag-n;
				for(n=0; n<offset; n++)
					buf[n]=buf[flag-offset+n];
			}
		}
		else
			offset=0;
	}
	if(offset != 0)
		for(n=0;n<offset;n++)
			putchar(buf[n]);
	return 0;
}
